package sun.java2d.d3d;

import sun.java2d.pipe.RenderBuffer;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.SurfaceType;
import sun.java2d.loops.Blit;

class D3DSurfaceToSwBlit extends Blit
{
    private int typeval;
    
    D3DSurfaceToSwBlit(SurfaceType dsttype, int typeval) {
        super(D3DSurfaceData.D3DSurface, CompositeType.SrcNoEa, dsttype);
        this.typeval = typeval;
    }
    
    @Override
    public void Blit(SurfaceData surfaceData, SurfaceData ref, Composite composite, Region region, int x, int x2, int x3, int x4, int x5, int x6) {
        D3DRenderQueue instance = D3DRenderQueue.getInstance();
        instance.lock();
        try {
            instance.addReference(ref);
            RenderBuffer buffer = instance.getBuffer();
            D3DContext.setScratchSurface(((D3DSurfaceData)surfaceData).getContext());
            instance.ensureCapacityAndAlignment(48, 32);
            buffer.putInt(34);
            buffer.putInt(x).putInt(x2);
            buffer.putInt(x3).putInt(x4);
            buffer.putInt(x5).putInt(x6);
            buffer.putInt(this.typeval);
            buffer.putLong(surfaceData.getNativeOps());
            buffer.putLong(ref.getNativeOps());
            instance.flushNow();
        }
        finally {
            instance.unlock();
        }
    }
}
